Index: kernel/arch/mips32/include/arch/mach/malta/malta.h
===================================================================
--- kernel/arch/mips32/include/arch/mach/malta/malta.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/mips32/include/arch/mach/malta/malta.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -38,4 +38,21 @@
 
 #include <arch/machine_func.h>
+#include <arch/mm/page.h>
+#include <typedefs.h>
+
+#define MALTA_PCI_PHYSBASE	0x18000000UL
+
+#define MALTA_PCI_BASE		PA2KSEG1(MALTA_PCI_PHYSBASE)
+#define MALTA_GT64120_BASE	PA2KSEG1(0x1be00000UL)
+
+#define PIC0_BASE		(MALTA_PCI_BASE + 0x20)
+#define PIC1_BASE		(MALTA_PCI_BASE + 0xa0)
+
+#define ISA_IRQ_COUNT		16
+
+#define TTY_BASE		(MALTA_PCI_PHYSBASE + 0x3f8)
+#define TTY_ISA_IRQ		4
+
+#define GT64120_PCI0_INTACK	((ioport32_t *) (MALTA_GT64120_BASE + 0xc34))
 
 extern struct mips32_machine_ops malta_machine_ops;
Index: kernel/arch/mips32/include/arch/mach/msim/dorder.h
===================================================================
--- kernel/arch/mips32/include/arch/mach/msim/dorder.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
+++ kernel/arch/mips32/include/arch/mach/msim/dorder.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -0,0 +1,47 @@
+/*
+ * Copyright (c) 2007 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kernel_mips32
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_mips32_DORDER_H_
+#define KERN_mips32_DORDER_H_
+
+#include <stdint.h>
+
+extern void dorder_init(void);
+extern uint32_t dorder_cpuid(void);
+extern void dorder_ipi_ack(uint32_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/mips32/include/arch/mach/msim/msim.h
===================================================================
--- kernel/arch/mips32/include/arch/mach/msim/msim.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/mips32/include/arch/mach/msim/msim.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -38,4 +38,14 @@
 
 #include <arch/machine_func.h>
+#include <arch/mm/page.h>
+
+/** Address of devices. */
+#define MSIM_VIDEORAM        PA2KSEG1(0x10000000)
+#define MSIM_KBD_ADDRESS     PA2KSEG1(0x10000000)
+#define MSIM_DORDER_ADDRESS  PA2KSEG1(0x10000100)
+
+#define MSIM_KBD_IRQ      2
+#define MSIM_DORDER_IRQ   5
+#define MSIM_DDISK_IRQ    6
 
 extern struct mips32_machine_ops msim_machine_ops;
Index: kernel/arch/mips32/include/arch/machine_func.h
===================================================================
--- kernel/arch/mips32/include/arch/machine_func.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/mips32/include/arch/machine_func.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -43,4 +43,5 @@
 
 #include <typedefs.h>
+#include <stdbool.h>
 
 struct mips32_machine_ops {
Index: kernel/arch/mips32/include/arch/mm/as.h
===================================================================
--- kernel/arch/mips32/include/arch/mm/as.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/mips32/include/arch/mm/as.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -37,4 +37,5 @@
 
 #define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH  0
+#define KERNEL_SEPARATE_PTL0_ARCH           0
 
 #define KERNEL_ADDRESS_SPACE_START_ARCH  UINT32_C(0x80000000)
Index: kernel/arch/mips32/include/arch/mm/page.h
===================================================================
--- kernel/arch/mips32/include/arch/mm/page.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/mips32/include/arch/mm/page.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -43,4 +43,6 @@
 
 #ifndef __ASSEMBLER__
+#	define KSEG12PA(x)	(((uintptr_t) (x)) - 0xa0000000)
+#	define PA2KSEG1(x)	(((uintptr_t) (x)) + 0xa0000000)
 #	define KA2PA(x)	(((uintptr_t) (x)) - 0x80000000)
 #	define PA2KA(x)	(((uintptr_t) (x)) + 0x80000000)
Index: kernel/arch/mips32/src/exception.c
===================================================================
--- kernel/arch/mips32/src/exception.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/mips32/src/exception.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -47,4 +47,5 @@
 #include <symtab.h>
 #include <log.h>
+#include <arch/machine_func.h>
 
 static const char *exctable[] = {
@@ -174,5 +175,5 @@
 
 	unsigned int i;
-	for (i = 0; i < 8; i++) {
+	for (i = 0; i < MIPS_INTERRUPTS; i++) {
 
 		/*
@@ -183,12 +184,7 @@
 		 */
 		if (im & ip & (1 << i)) {
-			irq_t *irq = irq_dispatch_and_lock(i);
-			if (irq) {
-				/*
-				 * The IRQ handler was found.
-				 */
-				irq->handler(irq);
-				irq_spinlock_unlock(&irq->lock, false);
-			} else {
+			if (int_handler[i])
+				int_handler[i](i);
+			else {
 				/*
 				 * Spurious interrupt.
Index: kernel/arch/mips32/src/interrupt.c
===================================================================
--- kernel/arch/mips32/src/interrupt.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/mips32/src/interrupt.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -38,21 +38,6 @@
 #include <arch.h>
 #include <arch/cp0.h>
-#include <arch/smp/dorder.h>
 #include <time/clock.h>
 #include <ipc/sysipc.h>
-
-#define IRQ_COUNT   8
-#define TIMER_IRQ   7
-
-#ifdef MACHINE_msim
-#define DORDER_IRQ  5
-#endif
-
-function virtual_timer_fnc = NULL;
-static irq_t timer_irq;
-
-#ifdef MACHINE_msim
-static irq_t dorder_irq;
-#endif
 
 // TODO: This is SMP unsafe!!!
@@ -61,4 +46,7 @@
 static unsigned long nextcount;
 static unsigned long lastcount;
+
+/** Table of interrupt handlers. */
+int_handler_t int_handler[MIPS_INTERRUPTS] = { };
 
 /** Disable interrupts.
@@ -122,10 +110,5 @@
 }
 
-static irq_ownership_t timer_claim(irq_t *irq)
-{
-	return IRQ_ACCEPT;
-}
-
-static void timer_irq_handler(irq_t *irq)
+static void timer_interrupt_handler(unsigned int intr)
 {
 	if (cp0_count_read() < lastcount)
@@ -144,51 +127,14 @@
 	cp0_compare_write(nextcount);
 
-	/*
-	 * We are holding a lock which prevents preemption.
-	 * Release the lock, call clock() and reacquire the lock again.
-	 */
-	irq_spinlock_unlock(&irq->lock, false);
 	clock();
-	irq_spinlock_lock(&irq->lock, false);
-
-	if (virtual_timer_fnc != NULL)
-		virtual_timer_fnc();
 }
-
-#ifdef MACHINE_msim
-static irq_ownership_t dorder_claim(irq_t *irq)
-{
-	return IRQ_ACCEPT;
-}
-
-static void dorder_irq_handler(irq_t *irq)
-{
-	dorder_ipi_ack(1 << dorder_cpuid());
-}
-#endif
 
 /* Initialize basic tables for exception dispatching */
 void interrupt_init(void)
 {
-	irq_init(IRQ_COUNT, IRQ_COUNT);
-
-	irq_initialize(&timer_irq);
-	timer_irq.inr = TIMER_IRQ;
-	timer_irq.claim = timer_claim;
-	timer_irq.handler = timer_irq_handler;
-	irq_register(&timer_irq);
+	int_handler[INT_TIMER] = timer_interrupt_handler;
 
 	timer_start();
-	cp0_unmask_int(TIMER_IRQ);
-
-#ifdef MACHINE_msim
-	irq_initialize(&dorder_irq);
-	dorder_irq.inr = DORDER_IRQ;
-	dorder_irq.claim = dorder_claim;
-	dorder_irq.handler = dorder_irq_handler;
-	irq_register(&dorder_irq);
-
-	cp0_unmask_int(DORDER_IRQ);
-#endif
+	cp0_unmask_int(INT_TIMER);
 }
 
Index: kernel/arch/mips32/src/mach/malta/malta.c
===================================================================
--- kernel/arch/mips32/src/mach/malta/malta.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/mips32/src/mach/malta/malta.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -38,4 +38,12 @@
 #include <console/chardev.h>
 #include <arch/mm/page.h>
+#include <genarch/drivers/i8259/i8259.h>
+#include <genarch/drivers/ns16550/ns16550.h>
+#include <genarch/srln/srln.h>
+#include <arch/interrupt.h>
+#include <stdbool.h>
+#include <byteorder.h>
+#include <sysinfo/sysinfo.h>
+#include <log.h>
 
 static void malta_init(void);
@@ -57,6 +65,54 @@
 };
 
+#ifdef CONFIG_NS16550
+static ns16550_instance_t *tty_instance;
+#endif
+#ifdef CONFIG_NS16550_OUT
+static outdev_t *tty_out;
+#endif
+
+static void malta_isa_irq_handler(unsigned int i)
+{
+	uint8_t isa_irq = host2uint32_t_le(pio_read_32(GT64120_PCI0_INTACK));
+	if (i8259_is_spurious(isa_irq)) {
+		i8259_handle_spurious(isa_irq);
+#ifdef CONFIG_DEBUG
+		log(LF_ARCH, LVL_DEBUG, "cpu%u: PIC spurious interrupt %u",
+		    CPU->id, isa_irq);
+		return;
+#endif
+	}
+	irq_t *irq = irq_dispatch_and_lock(isa_irq);
+	if (irq) {
+		irq->handler(irq);
+		irq_spinlock_unlock(&irq->lock, false);
+	} else {
+#ifdef CONFIG_DEBUG
+		log(LF_ARCH, LVL_DEBUG, "cpu%u: unhandled IRQ (irq=%u)",
+		    CPU->id, isa_irq);
+#endif
+	}
+	i8259_eoi(isa_irq);
+}
+
 void malta_init(void)
 {
+	irq_init(ISA_IRQ_COUNT, ISA_IRQ_COUNT);
+
+	i8259_init((i8259_t *) PIC0_BASE, (i8259_t *) PIC1_BASE, 0);
+	sysinfo_set_item_val("i8259", NULL, true);
+
+	int_handler[INT_HW0] = malta_isa_irq_handler;
+	cp0_unmask_int(INT_HW0);
+
+#if (defined(CONFIG_NS16550) || defined(CONFIG_NS16550_OUT))
+#ifdef CONFIG_NS16550_OUT
+	outdev_t **tty_out_ptr = &tty_out;
+#else
+	outdev_t **tty_out_ptr = NULL;
+#endif
+	tty_instance = ns16550_init((ioport8_t *) TTY_BASE, 0, TTY_ISA_IRQ,
+	    NULL, NULL, tty_out_ptr);
+#endif
 }
 
@@ -73,37 +129,25 @@
 }
 
-#define YAMON_SUBR_BASE         PA2KA(0x1fc00500)
-#define YAMON_SUBR_PRINT_COUNT  (YAMON_SUBR_BASE + 0x4)
-
-typedef void (**yamon_print_count_ptr_t)(uint32_t, const char *, uint32_t);
-
-yamon_print_count_ptr_t yamon_print_count =
-    (yamon_print_count_ptr_t) YAMON_SUBR_PRINT_COUNT;
-
-static void yamon_putwchar(outdev_t *dev, const wchar_t wch)
-{
-
-	const char ch = (char) wch;
-
-	(*yamon_print_count)(0, &ch, 1);
-}
-
-static outdev_t yamon_outdev;
-static outdev_operations_t yamon_outdev_ops = {
-	.write = yamon_putwchar,
-	.redraw = NULL,
-	.scroll_up = NULL,
-	.scroll_down = NULL
-};
-
 void malta_output_init(void)
 {
-	outdev_initialize("yamon", &yamon_outdev, &yamon_outdev_ops);
-	stdout_wire(&yamon_outdev);
+#ifdef CONFIG_NS16550_OUT
+	if (tty_out)
+		stdout_wire(tty_out);
+#endif
 }
 
 void malta_input_init(void)
 {
-	(void) stdin_wire();
+#ifdef CONFIG_NS16550
+	if (tty_instance) {
+		srln_instance_t *srln_instance = srln_init();
+		if (srln_instance) {
+			indev_t *sink = stdin_wire();
+			indev_t *srln = srln_wire(srln_instance, sink);
+			ns16550_wire(tty_instance, srln);
+			i8259_enable_irqs(1 << TTY_ISA_IRQ);
+		}
+	}
+#endif
 }
 
Index: kernel/arch/mips32/src/mach/msim/dorder.c
===================================================================
--- kernel/arch/mips32/src/mach/msim/dorder.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
+++ kernel/arch/mips32/src/mach/msim/dorder.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -0,0 +1,86 @@
+/*
+ * Copyright (c) 2007 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kernel_mips32
+ * @{
+ */
+/** @file
+ */
+
+#include <arch/mach/msim/dorder.h>
+#include <arch/mach/msim/msim.h>
+#include <stdint.h>
+#include <smp/ipi.h>
+#include <interrupt.h>
+#include <arch/asm.h>
+#include <typedefs.h>
+
+static irq_t dorder_irq;
+
+#ifdef CONFIG_SMP
+
+void ipi_broadcast_arch(int ipi)
+{
+	pio_write_32(((ioport32_t *) MSIM_DORDER_ADDRESS), 0x7fffffff);
+}
+
+#endif
+
+static irq_ownership_t dorder_claim(irq_t *irq)
+{
+	return IRQ_ACCEPT;
+}
+
+static void dorder_irq_handler(irq_t *irq)
+{
+	dorder_ipi_ack(1 << dorder_cpuid());
+}
+
+void dorder_init(void)
+{
+	irq_initialize(&dorder_irq);
+	dorder_irq.inr = MSIM_DORDER_IRQ;
+	dorder_irq.claim = dorder_claim;
+	dorder_irq.handler = dorder_irq_handler;
+	irq_register(&dorder_irq);
+
+	cp0_unmask_int(MSIM_DORDER_IRQ);
+}
+
+uint32_t dorder_cpuid(void)
+{
+	return pio_read_32((ioport32_t *) MSIM_DORDER_ADDRESS);
+}
+
+void dorder_ipi_ack(uint32_t mask)
+{
+	pio_write_32((ioport32_t *) (MSIM_DORDER_ADDRESS + 4), mask);
+}
+
+/** @}
+ */
Index: kernel/arch/mips32/src/mach/msim/msim.c
===================================================================
--- kernel/arch/mips32/src/mach/msim/msim.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/mips32/src/mach/msim/msim.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -35,10 +35,11 @@
 
 #include <arch/mach/msim/msim.h>
+#include <arch/mach/msim/dorder.h>
 #include <console/console.h>
 #include <sysinfo/sysinfo.h>
-#include <arch/drivers/msim.h>
 #include <genarch/drivers/dsrln/dsrlnin.h>
 #include <genarch/drivers/dsrln/dsrlnout.h>
 #include <genarch/srln/srln.h>
+#include <stdbool.h>
 
 static void msim_init(void);
@@ -60,6 +61,29 @@
 };
 
+static void msim_irq_handler(unsigned int i)
+{
+	irq_t *irq = irq_dispatch_and_lock(i);
+	if (irq) {
+		irq->handler(irq);
+		irq_spinlock_unlock(&irq->lock, false);
+	} else {
+#ifdef CONFIG_DEBUG
+		log(LF_ARCH, LVL_DEBUG, "cpu%u: spurious IRQ (irq=%u)",
+		    CPU->id, i);
+#endif
+	}
+}
+
 void msim_init(void)
 {
+	irq_init(HW_INTERRUPTS, HW_INTERRUPTS);
+
+	int_handler[INT_HW0] = msim_irq_handler;
+	int_handler[INT_HW1] = msim_irq_handler;
+	int_handler[INT_HW2] = msim_irq_handler;
+	int_handler[INT_HW3] = msim_irq_handler;
+	int_handler[INT_HW4] = msim_irq_handler;
+
+	dorder_init();
 	cp0_unmask_int(MSIM_DDISK_IRQ);
 }
@@ -80,5 +104,6 @@
 {
 #ifdef CONFIG_MSIM_PRN
-	outdev_t *dsrlndev = dsrlnout_init((ioport8_t *) MSIM_KBD_ADDRESS);
+	outdev_t *dsrlndev = dsrlnout_init((ioport8_t *) MSIM_KBD_ADDRESS,
+	    KSEG12PA(MSIM_KBD_ADDRESS));
 	if (dsrlndev)
 		stdout_wire(dsrlndev);
Index: kernel/arch/mips32/src/mips32.c
===================================================================
--- kernel/arch/mips32/src/mips32.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/mips32/src/mips32.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -71,11 +71,7 @@
 arch_ops_t *arch_ops = &mips32_ops;
 
-/*
- * Why the linker moves the variable 64K away in assembler
- * when not in .text section?
- */
-
 /* Stack pointer saved when entering user mode */
-uintptr_t supervisor_sp __attribute__((section(".text")));
+// FIXME: This won't work with SMP unless thread creation is globally serialized.
+uintptr_t supervisor_sp;
 
 size_t cpu_count = 0;
@@ -107,4 +103,6 @@
 #endif
 
+	str_cpy(bargs, CONFIG_BOOT_ARGUMENTS_BUFLEN, bootinfo->bootargs);
+
 	/* Initialize machine_ops pointer. */
 	machine_ops_init();
@@ -169,9 +167,9 @@
 	cp0_status_write(cp0_status_read() | (cp0_status_exl_exception_bit |
 	    cp0_status_um_bit | cp0_status_ie_enabled_bit));
-	cp0_epc_write((uintptr_t) kernel_uarg->uspace_entry);
-	userspace_asm(((uintptr_t) kernel_uarg->uspace_stack +
-	    kernel_uarg->uspace_stack_size),
-	    (uintptr_t) kernel_uarg->uspace_uarg,
-	    (uintptr_t) kernel_uarg->uspace_entry);
+	cp0_epc_write(kernel_uarg->uspace_entry);
+	userspace_asm(kernel_uarg->uspace_stack +
+	    kernel_uarg->uspace_stack_size,
+	    kernel_uarg->uspace_uarg,
+	    kernel_uarg->uspace_entry);
 
 	while (true)
Index: kernel/arch/mips32/src/mm/frame.c
===================================================================
--- kernel/arch/mips32/src/mm/frame.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/mips32/src/mm/frame.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -41,5 +41,5 @@
 #include <config.h>
 #ifdef MACHINE_msim
-#include <arch/drivers/msim.h>
+#include <arch/mach/msim/msim.h>
 #endif
 #include <arch/arch.h>
@@ -57,5 +57,5 @@
 
 #define ZERO_PAGE_VALUE_KSEG1(frame) \
-	(((volatile uint32_t *) (0xa0000000 + (frame << ZERO_PAGE_WIDTH)))[ZERO_PAGE_OFFSET])
+	(((volatile uint32_t *) PA2KSEG1(frame << ZERO_PAGE_WIDTH))[ZERO_PAGE_OFFSET])
 
 #define MAX_REGIONS  32
@@ -80,9 +80,9 @@
 #ifdef MACHINE_msim
 	/* MSIM device (dprinter) */
-	if (frame == (KA2PA(MSIM_VIDEORAM) >> ZERO_PAGE_WIDTH))
+	if (frame == (KSEG12PA(MSIM_VIDEORAM) >> ZERO_PAGE_WIDTH))
 		return false;
 
 	/* MSIM device (dkeyboard) */
-	if (frame == (KA2PA(MSIM_KBD_ADDRESS) >> ZERO_PAGE_WIDTH))
+	if (frame == (KSEG12PA(MSIM_KBD_ADDRESS) >> ZERO_PAGE_WIDTH))
 		return false;
 #endif
Index: kernel/arch/ppc32/Makefile.inc
===================================================================
--- kernel/arch/ppc32/Makefile.inc	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ppc32/Makefile.inc	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -28,6 +28,5 @@
 
 
-COMMON_CFLAGS += -mcpu=powerpc -msoft-float -m32
-AFLAGS += -a32
+COMMON_CFLAGS += -mcpu=powerpc -msoft-float -m32 -Wa,-a32
 LDFLAGS += -Wl,-no-check-sections
 
Index: kernel/arch/ppc32/include/arch/mm/as.h
===================================================================
--- kernel/arch/ppc32/include/arch/mm/as.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ppc32/include/arch/mm/as.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -39,4 +39,5 @@
 
 #define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH  0
+#define KERNEL_SEPARATE_PTL0_ARCH           0
 
 #define KERNEL_ADDRESS_SPACE_START_ARCH  UINT32_C(0x80000000)
Index: kernel/arch/ppc32/src/debug/stacktrace.c
===================================================================
--- kernel/arch/ppc32/src/debug/stacktrace.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ppc32/src/debug/stacktrace.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -67,12 +67,12 @@
 bool uspace_frame_pointer_prev(stack_trace_context_t *ctx, uintptr_t *prev)
 {
-	return !copy_from_uspace((void *) prev,
-	    (uint32_t *) ctx->fp + FRAME_OFFSET_FP_PREV, sizeof(*prev));
+	return !copy_from_uspace(prev,
+	    ctx->fp + sizeof(uintptr_t) * FRAME_OFFSET_FP_PREV, sizeof(*prev));
 }
 
 bool uspace_return_address_get(stack_trace_context_t *ctx, uintptr_t *ra)
 {
-	return !copy_from_uspace((void *) ra,
-	    (uint32_t *) ctx->fp + FRAME_OFFSET_RA, sizeof(*ra));
+	return !copy_from_uspace(ra,
+	    ctx->fp + sizeof(uintptr_t) * FRAME_OFFSET_RA, sizeof(*ra));
 }
 
Index: kernel/arch/ppc32/src/drivers/pic.c
===================================================================
--- kernel/arch/ppc32/src/drivers/pic.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ppc32/src/drivers/pic.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -37,6 +37,7 @@
 #include <byteorder.h>
 #include <bitops.h>
+#include <typedefs.h>
 
-static volatile uint32_t *pic = NULL;
+static ioport32_t *pic = NULL;
 
 void pic_init(uintptr_t base, size_t size, cir_t *cir, void **cir_arg)
@@ -50,20 +51,27 @@
 void pic_enable_interrupt(inr_t intnum)
 {
-	if (pic) {
-		if (intnum < 32)
-			pic[PIC_MASK_LOW] = pic[PIC_MASK_LOW] | (1 << intnum);
-		else
-			pic[PIC_MASK_HIGH] = pic[PIC_MASK_HIGH] | (1 << (intnum - 32));
+	if (!pic)
+		return;
+
+	if (intnum < 32) {
+		pio_write_32(&pic[PIC_MASK_LOW],
+		    pio_read_32(&pic[PIC_MASK_LOW]) | (1 << intnum));
+	} else {
+		pio_write_32(&pic[PIC_MASK_HIGH],
+		    pio_read_32(&pic[PIC_MASK_HIGH]) | (1 << (intnum - 32)));
 	}
-
 }
 
 void pic_disable_interrupt(inr_t intnum)
 {
-	if (pic) {
-		if (intnum < 32)
-			pic[PIC_MASK_LOW] = pic[PIC_MASK_LOW] & (~(1 << intnum));
-		else
-			pic[PIC_MASK_HIGH] = pic[PIC_MASK_HIGH] & (~(1 << (intnum - 32)));
+	if (!pic)
+		return;
+
+	if (intnum < 32) {
+		pio_write_32(&pic[PIC_MASK_LOW],
+		    pio_read_32(&pic[PIC_MASK_LOW]) & (~(1 << intnum)));
+	} else {
+		pio_write_32(&pic[PIC_MASK_HIGH],
+		    pio_read_32(&pic[PIC_MASK_HIGH]) & (~(1 << (intnum - 32))));
 	}
 }
@@ -71,9 +79,11 @@
 void pic_ack_interrupt(void *arg, inr_t intnum)
 {
-	if (pic) {
-		if (intnum < 32)
-			pic[PIC_ACK_LOW] = 1 << intnum;
-		else
-			pic[PIC_ACK_HIGH] = 1 << (intnum - 32);
+	if (!pic)
+		return;
+
+	if (intnum < 32) {
+		pio_write_32(&pic[PIC_ACK_LOW], 1 << intnum);
+	} else {
+		pio_write_32(&pic[PIC_ACK_HIGH], 1 << (intnum - 32));
 	}
 }
@@ -87,9 +97,9 @@
 		uint32_t pending;
 
-		pending = pic[PIC_PENDING_LOW];
+		pending = pio_read_32(&pic[PIC_PENDING_LOW]);
 		if (pending != 0)
 			return fnzb32(pending);
 
-		pending = pic[PIC_PENDING_HIGH];
+		pending = pio_read_32(&pic[PIC_PENDING_HIGH]);
 		if (pending != 0)
 			return fnzb32(pending) + 32;
Index: kernel/arch/ppc32/src/interrupt.c
===================================================================
--- kernel/arch/ppc32/src/interrupt.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ppc32/src/interrupt.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -141,4 +141,6 @@
 			    " (inum=%" PRIu8 ")", CPU->id, inum);
 #endif
+			pic_ack_interrupt(NULL, inum);
+			break;
 		}
 	}
Index: kernel/arch/ppc32/src/ppc32.c
===================================================================
--- kernel/arch/ppc32/src/ppc32.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/ppc32/src/ppc32.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -292,8 +292,8 @@
 void userspace(uspace_arg_t *kernel_uarg)
 {
-	userspace_asm((uintptr_t) kernel_uarg->uspace_uarg,
-	    (uintptr_t) kernel_uarg->uspace_stack +
+	userspace_asm(kernel_uarg->uspace_uarg,
+	    kernel_uarg->uspace_stack +
 	    kernel_uarg->uspace_stack_size - SP_DELTA,
-	    (uintptr_t) kernel_uarg->uspace_entry);
+	    kernel_uarg->uspace_entry);
 
 	unreachable();
Index: kernel/arch/riscv64/_link.ld.in
===================================================================
--- kernel/arch/riscv64/_link.ld.in	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/riscv64/_link.ld.in	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -16,5 +16,5 @@
 	kernel_load_address = PA2KA(BOOT_OFFSET);
 
-	.image (PA2KA(BOOT_OFFSET) + SIZEOF_HEADERS) : AT (SIZEOF_HEADERS) {
+	.image (PA2KA(BOOT_OFFSET) + SIZEOF_HEADERS) : AT (BOOT_OFFSET + SIZEOF_HEADERS) {
 		ktext_start = .;
 		*(K_TEXT_START);
Index: kernel/arch/riscv64/include/arch/mm/as.h
===================================================================
--- kernel/arch/riscv64/include/arch/mm/as.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/riscv64/include/arch/mm/as.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -40,4 +40,5 @@
 
 #define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH  0
+#define KERNEL_SEPARATE_PTL0_ARCH           0
 
 #define KERNEL_ADDRESS_SPACE_START_ARCH  UINT64_C(0xffff800000000000)
Index: kernel/arch/riscv64/src/riscv64.c
===================================================================
--- kernel/arch/riscv64/src/riscv64.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/riscv64/src/riscv64.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -143,10 +143,10 @@
 }
 
-uintptr_t memcpy_from_uspace(void *dst, const void *uspace_src, size_t size)
+uintptr_t memcpy_from_uspace(void *dst, uspace_addr_t uspace_src, size_t size)
 {
 	return 0;
 }
 
-uintptr_t memcpy_to_uspace(void *uspace_dst, const void *src, size_t size)
+uintptr_t memcpy_to_uspace(uspace_addr_t uspace_dst, const void *src, size_t size)
 {
 	return 0;
Index: kernel/arch/sparc64/Makefile.inc
===================================================================
--- kernel/arch/sparc64/Makefile.inc	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/sparc64/Makefile.inc	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -82,4 +82,5 @@
 	arch/$(KARCH)/src/drivers/tick.c \
 	arch/$(KARCH)/src/drivers/kbd.c \
+	arch/$(KARCH)/src/drivers/tty.c \
 	arch/$(KARCH)/src/drivers/pci.c \
 	arch/$(KARCH)/src/trap/$(USARCH)/interrupt.c
Index: kernel/arch/sparc64/include/arch/drivers/tty.h
===================================================================
--- kernel/arch/sparc64/include/arch/drivers/tty.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
+++ kernel/arch/sparc64/include/arch/drivers/tty.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2019 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kernel_sparc64
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_sparc64_TTY_H_
+#define KERN_sparc64_TTY_H_
+
+#include <genarch/ofw/ofw_tree.h>
+
+extern void tty_init(ofw_tree_node_t *node);
+
+#endif
+
+/** @}
+ */
Index: kernel/arch/sparc64/include/arch/mm/sun4u/as.h
===================================================================
--- kernel/arch/sparc64/include/arch/mm/sun4u/as.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/sparc64/include/arch/mm/sun4u/as.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -39,4 +39,5 @@
 
 #define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH  1
+#define KERNEL_SEPARATE_PTL0_ARCH           0
 
 #define KERNEL_ADDRESS_SPACE_START_ARCH  UINT64_C(0x0000000000000000)
Index: kernel/arch/sparc64/include/arch/mm/sun4v/as.h
===================================================================
--- kernel/arch/sparc64/include/arch/mm/sun4v/as.h	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/sparc64/include/arch/mm/sun4v/as.h	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -41,4 +41,5 @@
 
 #define KERNEL_ADDRESS_SPACE_SHADOWED_ARCH  1
+#define KERNEL_SEPARATE_PTL0_ARCH           0
 
 #define KERNEL_ADDRESS_SPACE_START_ARCH  UINT64_C(0x0000000000000000)
Index: kernel/arch/sparc64/src/console.c
===================================================================
--- kernel/arch/sparc64/src/console.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/sparc64/src/console.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -37,4 +37,5 @@
 #include <arch/drivers/scr.h>
 #include <arch/drivers/kbd.h>
+#include <arch/drivers/tty.h>
 #include <genarch/srln/srln.h>
 #include <console/chardev.h>
@@ -84,4 +85,13 @@
 	kbd_init(keyboard);
 #endif
+
+#ifdef CONFIG_SUN_TTY
+	ofw_tree_property_t *prop_tty = ofw_tree_getprop(aliases, "ttya");
+	if (prop_tty && prop_tty->value) {
+		ofw_tree_node_t *tty = ofw_tree_lookup(prop_tty->value);
+		if (tty)
+			tty_init(tty);
+	}
+#endif
 }
 
Index: kernel/arch/sparc64/src/drivers/kbd.c
===================================================================
--- kernel/arch/sparc64/src/drivers/kbd.c	(revision 46288eef683d4b03bcbb084da70081298922bd22)
+++ kernel/arch/sparc64/src/drivers/kbd.c	(revision b781cc497418aafed520d245eab50c6954c84dcd)
@@ -38,7 +38,4 @@
 #include <console/console.h>
 #include <ddi/irq.h>
-#include <mm/page.h>
-#include <arch/mm/page.h>
-#include <mm/km.h>
 #include <typedefs.h>
 #include <align.h>
@@ -88,6 +85,4 @@
 	}
 
-	size_t size = ((ofw_ebus_reg_t *) prop->value)->size;
-
 	uintptr_t pa = 0; // Prevent -Werror=maybe-uninitialized
 	if (!ofw_ebus_apply_ranges(node->parent,
@@ -109,9 +104,6 @@
 	}
 
-	ioport8_t *ns16550 = (ioport8_t *) km_map(pa, size,
-	    KM_NATURAL_ALIGNMENT, PAGE_WRITE | PAGE_NOT_CACHEABLE);
-
-	ns16550_instance_t *ns16550_instance = ns16550_init(ns16550, 0, inr, cir,
-	    cir_arg, NULL);
+	ns16550_instance_t *ns16550_instance = ns16550_init((ioport8_t *) pa, 0,
+	    inr, cir, cir_arg, NULL);
 	if (ns16550_instance) {
 		kbrd_instance_t *kbrd_instance = kbrd_init();
